Object.defineProperty(exports, "__esModule", { value: true });
var day_scope_1 = require("./day-scope");
var year_scope_1 = require("./year-scope");
var month_scope_1 = require("./month-scope");
var defaultScopesArray = [
    new year_scope_1.YearScope(),
    new month_scope_1.MonthScope(),
    new day_scope_1.DayScope()
].map(function (scope, index, array) {
    if (index + 1 < array.length) {
        scope.setNextScope(array[index + 1]);
    }
    if (index - 1 >= 0) {
        scope.setPreviousScope(array[index - 1]);
    }
    return scope;
});
exports.DEFAULT_SCOPES = {
    array: defaultScopesArray,
    initial: defaultScopesArray[defaultScopesArray.length - 1]
};
