var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var abstract_scope_1 = require("./abstract-scope");
var HourScope = (function (_super) {
    __extends(HourScope, _super);
    function HourScope() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HourScope.prototype.next = function (selectedDate) {
        return date_fns_1.addDays(selectedDate, 1);
    };
    HourScope.prototype.previous = function (selectedDate) {
        return date_fns_1.addDays(selectedDate, -1);
    };
    HourScope.prototype.getItems = function (selectedDate) {
        var initialDate = [selectedDate]
            .map(function (date) { return date_fns_1.startOfDay(date); })
            .pop();
        var hours = Array.from(new Array(12), function (_, index) { return date_fns_1.addHours(initialDate, index); });
        return hours;
    };
    HourScope.prototype.formatDate = function (date, locale) {
        var options = locale ? { locale: locale } : this._formattiongOptions;
        return date_fns_1.format(date, 'HH', options);
    };
    HourScope.prototype.title = function (date) {
        return date_fns_1.format(date, 'DD. MM. YYYY');
    };
    HourScope.prototype.isEqual = function (a, b) {
        return this.previousScopeIsEqual(a, b)
            && date_fns_1.getHours(a) === date_fns_1.getHours(b);
    };
    return HourScope;
}(abstract_scope_1.AbstractScope));
exports.HourScope = HourScope;
