var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var abstract_scope_1 = require("./abstract-scope");
var MinuteScope = (function (_super) {
    __extends(MinuteScope, _super);
    function MinuteScope() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MinuteScope.prototype.next = function (selectedDate) {
        return date_fns_1.addHours(selectedDate, 1);
    };
    MinuteScope.prototype.previous = function (selectedDate) {
        return date_fns_1.addHours(selectedDate, -1);
    };
    MinuteScope.prototype.getItems = function (selectedDate) {
        var initialDate = [selectedDate]
            .map(function (date) { return date_fns_1.startOfDay(date); })
            .map(function (date) { return date_fns_1.startOfHour(date); })
            .pop();
        var minutes = Array.from(new Array(12), function (_, index) { return date_fns_1.addMinutes(initialDate, index * 5); });
        return minutes;
    };
    MinuteScope.prototype.formatDate = function (date) {
        return date_fns_1.format(date, 'mm');
    };
    MinuteScope.prototype.title = function (date) {
        return date_fns_1.format(date, 'DD. MM. YYYY');
    };
    MinuteScope.prototype.isEqual = function (a, b) {
        return this.previousScopeIsEqual(a, b)
            && date_fns_1.getMinutes(a) === date_fns_1.getMinutes(b);
    };
    return MinuteScope;
}(abstract_scope_1.AbstractScope));
exports.MinuteScope = MinuteScope;
