var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var abstract_scope_1 = require("./abstract-scope");
var helpers_1 = require("./helpers");
var MonthScope = (function (_super) {
    __extends(MonthScope, _super);
    function MonthScope() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MonthScope.prototype.next = function (selectedDate) {
        return date_fns_1.addYears(selectedDate, 1);
    };
    MonthScope.prototype.previous = function (selectedDate) {
        return date_fns_1.addYears(selectedDate, -1);
    };
    MonthScope.prototype.getItems = function (selectedDate) {
        var initialDate = [selectedDate]
            .map(function (date) { return date_fns_1.startOfMonth(date); })
            .map(function (date) { return helpers_1.getFirstDayOfWeek(date); })
            .map(function (date) { return date_fns_1.startOfDay(date); })
            .pop();
        var months = Array.from(new Array(12), function (_, index) { return date_fns_1.addMonths(initialDate, index); });
        return months;
    };
    MonthScope.prototype.formatDate = function (date, locale) {
        var options = locale ? { locale: locale } : this._formattiongOptions;
        return date_fns_1.format(date, 'MMM', options);
    };
    MonthScope.prototype.title = function (date) {
        return date_fns_1.format(date, 'YYYY');
    };
    MonthScope.prototype.isEqual = function (a, b) {
        return this.previousScopeIsEqual(a, b)
            && date_fns_1.getMonth(a) === date_fns_1.getMonth(b);
    };
    return MonthScope;
}(abstract_scope_1.AbstractScope));
exports.MonthScope = MonthScope;
