var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var abstract_scope_1 = require("./abstract-scope");
var YearScope = (function (_super) {
    __extends(YearScope, _super);
    function YearScope() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    YearScope.prototype.next = function (selectedDate) {
        return date_fns_1.addYears(selectedDate, 10);
    };
    YearScope.prototype.previous = function (selectedDate) {
        return date_fns_1.addYears(selectedDate, -10);
    };
    YearScope.prototype.getItems = function (selectedDate) {
        var initialDate = [selectedDate]
            .map(function (date) { return date_fns_1.startOfYear(date); })
            .pop();
        var years = Array.from(new Array(12), function (_, index) { return date_fns_1.addYears(initialDate, index); });
        return years;
    };
    YearScope.prototype.formatDate = function (date) {
        return date_fns_1.format(date, 'YYYY');
    };
    YearScope.prototype.title = function (date) {
        var nextDecade = date_fns_1.addYears(date, 11);
        var start = date_fns_1.format(date, 'YYYY');
        var end = date_fns_1.format(nextDecade, 'YYYY');
        return start + " - " + end;
    };
    YearScope.prototype.isEqual = function (a, b) {
        return this.previousScopeIsEqual(a, b)
            && date_fns_1.getYear(a) === date_fns_1.getYear(b);
    };
    return YearScope;
}(abstract_scope_1.AbstractScope));
exports.YearScope = YearScope;
