define(["require", "exports", "./day-scope", "./year-scope", "./month-scope"], function (require, exports, day_scope_1, year_scope_1, month_scope_1) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var defaultScopesArray = [
        new year_scope_1.YearScope(),
        new month_scope_1.MonthScope(),
        new day_scope_1.DayScope()
    ].map(function (scope, index, array) {
        if (index + 1 < array.length) {
            scope.setNextScope(array[index + 1]);
        }
        if (index - 1 >= 0) {
            scope.setPreviousScope(array[index - 1]);
        }
        return scope;
    });
    exports.DEFAULT_SCOPES = {
        array: defaultScopesArray,
        initial: defaultScopesArray[defaultScopesArray.length - 1]
    };
});
